dofile_once( "files/lib/lib.lua" )
dofile_once( "config.lua" )

local homing_filepath = "files/entities/homing_default.xml,"
local vfx_path = "data/entities/particles/tinyspark_white.xml,"
local mana_cost = 50

-- for altered values
if Adjust_Homing_Coeff == true then
	homing_filepath = "files/entities/homing.xml,"
end
if Reduced_Homing_Mana_Cost == true then
	mana_cost = 20
end
if Remove_Homing_VFX == true then
	vfx_path=""
end

idx = tablefindindex(actions, "HOMING")
actions[idx] = {
	id          = "HOMING",
	name 		= "$action_homing",
	description = "$actiondesc_homing",
	sprite 		= "data/ui_gfx/gun_actions/homing.png",
	sprite_unidentified = "data/ui_gfx/gun_actions/homing_unidentified.png",
	type 		= ACTION_TYPE_MODIFIER,
	spawn_level                       = "2,3,4,5,6", -- HOMING
	spawn_probability                 = "1,1,1,1,1", -- HOMING
	price = 130,
	mana = mana_cost,
	action 		= function()
		c.extra_entities = c.extra_entities .. homing_filepath .. vfx_path
		draw_actions( 1, true )
	end,
}