dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "config.lua" )

-- called with homing entity to set projectile targets
-- seems to work as intended! targets homing_target nearest cursor position, can target other hittables with mouseover

local entity_id = GetUpdatedEntityID()

local projectile_component = EntityGetFirstComponent( entity_id, "ProjectileComponent")
local shooter = nil
if ( projectile_component ~= nil ) then
	shooter = ComponentGetValue( projectile_component, "mWhoShot")
end



if IsPlayer(shooter) == true then -- only do targeting if shooter is player -- seems to work

	local cursor_x, cursor_y = DEBUG_GetMouseWorld()

	local lock_on_target = nil -- store target we want to set
	local nearest_target,distance_to_nearest,nearest_x,nearest_y = nil -- id, distance and transform for nearest "homing_target"
	local mouseover_target,distance_to_mouseover,over_x,over_y = nil -- id, distance and transform for "hittable" mouseover entity

	-- repurposed destruction code to find nearest
	local homing_targets = EntityGetWithTag( "homing_target" )
	if ( #homing_targets > 0 ) then
		for i,target_id in ipairs(homing_targets) do
			local ex, ey = EntityGetTransform( target_id )
			local dist = math.sqrt( ( cursor_x - ex ) ^ 2 + ( cursor_y - ey ) ^ 2 )
			if (dist <= Lock_on_Radius) then
				if (nearest_target == nil) or dist < distance_to_nearest then
					nearest_target = target_id
					distance_to_nearest = dist
					nearest_x,nearest_y = ex,ey
				end
			end
		end
	end

	local hittables = EntityGetWithTag( "hittable" )
	if ( #hittables > 0 ) then
		for i,hittable_id in ipairs(hittables) do
			local skip_this_id = false
			if hittable_id == shooter then
				skip_this_id = true
			else
				local tag_string = EntityGetTags (hittable_id) -- get tags into string
				if tag_string ~= nil then
					if ( string.find(tag_string, "item") ~=nil ) then -- ignores items
						skip_this_id = true
					end
				end
			end
			if skip_this_id == false then
				local ex, ey = EntityGetTransform( hittable_id )
				local dist = math.sqrt( ( cursor_x - ex ) ^ 2 + ( cursor_y - ey ) ^ 2 )
				if (dist <= Override_Radius) then
					if (mouseover_target == nil) or dist < distance_to_mouseover then
						mouseover_target = hittable_id
						distance_to_mouseover = dist
						over_x,over_y = ex,ey
					end
				end
			end
		end
	end

	-- use mouseover_target, otherwise use nearest_target
	if mouseover_target ~= nil then -- if found mouse_over target, use that
		lock_on_target = mouseover_target
	elseif nearest_target ~= nil then -- otherwise use nearest_target
		lock_on_target = nearest_target
	end

	-- doublecheck homing and lock_on_target then set mPredefinedTarget to lock_on_target
	local homing_comps = EntityGetComponent( entity_id, "HomingComponent" )
	if( homing_comps ~= nil ) and lock_on_target ~= nil then
		for i,homing in ipairs(homing_comps) do
			ComponentSetValue( homing, "mPredefinedTarget", lock_on_target)
		end
	end
end